#include "stdafx.h"
#include "employee.h"
#include "boss.h"
#include "commissionWorker.h"
#include "hourlyWorker.h"
#include "pieceWorker.h"
#include <iostream>
#include <iomanip>
using namespace std;

void vPointer(employee *);
void vReference(employee &);
int main()
{
    cout << setiosflags(ios::fixed | ios::showpoint) << setprecision(2);
    boss b(" Bahram", " alizadeh", 800);
    commissionWorker c(" Ali", " ahmadi", 200, 3, 150);
    pieceWorker p(" Ahmad", " razavi", 2.5, 200);
    hourlyWorker h(" Mohsen", " alizadeh", 13.75, 40);
	cout << endl << "Using statc binding : " ;

	b.print();                                        //static binding
    cout << " earned "<< b.earnings() << " Tomans " ; //static binding
    c.print();                                        //static binding
    cout << " earned " << c.earnings() << " Tomans" ; //static binding
    p.print();
    cout << " earned  " << p.earnings() << " Tomans";
    h.print();
    cout << " earned " << h.earnings() << " Tomans" ;

	cout << endl << "\nUsing dynamic binding via base class pointer : "  ;
	vPointer(&b);        //uses dynamic binding
    vPointer(&c);         //uses dynamic binding
    vPointer(&p);           //uses dynamic binding
    vPointer(&h);           //uses dynamic binding

	cout << endl << "\nUsing dynamic binding via base class refrence : " ;
    vReference(b);       //uses dynamic binding
    vReference(c);        //uses dynamic binding
    vReference(p);          //uses dynamic binding
    vReference(h);          //uses dynamic binding
    cin.get();
}
//*******************8
void vPointer(employee *baseptr)
{
   baseptr -> print();
   cout << " earned  " << baseptr -> earnings() << " Tomans" ;
}
//*****************
void vReference(employee &baseref)
{
 baseref.print();
 cout << " earned  " << baseref.earnings() << " Tomans" ;
}
