#include "StdAfx.h"
#include "pieceWorker.h"
#include <iostream>
using namespace std;

pieceWorker::pieceWorker(const string &first, const string &last,
	     double w, int q)
	     :employee(first, last) //call base-constructor
{
    setWage(w);
    setQuantity(q);
}
//*************
void pieceWorker::setWage(double w)
{
   wagePerPiece = w > 0 ? w : 0;
}
//******************
void pieceWorker::setQuantity(int q)
{
   quantity = q > 0 ? q : 0;
}
//**********************
double pieceWorker::earnings() const
{
   return quantity * wagePerPiece;
}
//*******************
void pieceWorker::print() const
{
    cout << "\npiece worker:";
    employee::print();
}
