//member function for time class
//time constructor initializes each data member .
//ensure all time objects start in a consistent state.
#include "stdafx.h"
#include "time.h"
#include <iostream>
using namespace std;

time::time() 
{
	hour = 	12;
	minute = 0;
	second = 0;
}
//********************
//set time
void time::setTime(int h, int m, int s)
{
  hour   = (h >= 0 && h < 24) ? h : 0;
  minute = (m >= 0 && m < 60) ? m : 0;
  second = (s >= 0 && s < 60) ? s : 0;
}
//*********** print time  ************
void time::printStandard()
{
  cout << (( hour == 0 || hour == 12) ? 12 : hour % 12)
       << " : " << (minute < 10 ? "0" : "") << minute
       << " : " << (second < 10 ? "0" : "") << second
       << (hour < 12 ? " AM" : " PM");
}
