#include "stdafx.h"
#include <iostream>
#include <string>
using namespace std;

int main()
{
   // compiler concatenates all parts into one string
   string str( "The values in any left subtree"
      "\n are less than the value in the"
      "\n parent node and the values in"
      "\n any right subtree are greater"
      "\n than the value in the parent node" );
   cout << "Demonstrate the replace function \n\n";
   cout << " Original string:\n" << str << endl ;

   // remove all characters from (and including) location 62 
   // through the end of str
   str.erase( 62 );

   // output new string
   cout << "Original string after erase:\n" << str
      << "\n\nAfter first replacement:\n";
             
   int position = str.find( " " ); // find first space

   // replace all spaces with period
   while ( position != string::npos ) 
   {
      str.replace( position, 1, "." );
      position = str.find( " ", position + 1 );
   } // end while
    
   cout << str << "\n\nAfter second replacement:\n";
   
   position = str.find( "." ); // find first period

   // replace all periods with two semicolons
   // NOTE: this will overwrite characters
   while ( position != string::npos )
   {
      str.replace( position, 2, "xxxxx;;yyy", 5, 2 );
      position = str.find( ".", position + 1 );
   } // end while

   cout << str << endl;

   //demonstrate ehe insert function
   string string1( "beginning end" );
   string string2( "middle " );
   string string3( "12345678" );
   string string4( "xx" );
   cout << "\nDemonstarte the insert function" << endl;
   cout << "Initial strings:\nstring1: " << string1
     << "\nstring2: " << string2 << "\nstring3: " << string3
     << "\nstring4: " << string4 << "\n\n";

   // insert "middle" at location 10 in string1
   string1.insert( 10, string2 );

   // insert "xx" at location 3 in string3
   string3.insert( 3, string4, 0, string::npos );

   cout << "Strings after insert:\nstring1: " << string1
      << "\nstring2: " << string2 << "\nstring3: " << string3
      << "\nstring4: " << string4 << endl;
   cin.get();
} // end main
