#include "stdafx.h"
#include "gradeBank.h"
#include <iostream>
#include <iomanip>
using namespace std;
//constructor to initialize courseName and grade
gradeBank::gradeBank( string name, const int gradeArray[])
{
	setCourseName( name );
	//copy grades from gradeArray to grades data member
	for ( int i = 0; i < 10; i ++)
		grades[ i ] = gradeArray[ i ];
} //end of constructor
//***************   set CourseName *****
void gradeBank::setCourseName( string name )
{
	courseName = name;
} //end of setCourseName
//********** get courseName *****
string gradeBank::getCourseName()
{
	return courseName;
} //end of getCourseNane
//***********************
void gradeBank::display()
{
	cout << "You are in grade bank for " << getCourseName();
	cout << endl;
} //end of display
//********* operations on data***********
void gradeBank::gradeProcess()
{
	outputGrades();  //output gradesarray
	//display average , minimum, maximum
	cout << "\n Class average is " << setprecision(2) << fixed  << getAverage();
	cout << "\n Lowest grade is  " << getMinimum();
	cout << "\n Highest grade is " << getMaximum() << endl;
} //end of gradeProcess
//********** find minimum grade *********
int gradeBank::getMinimum ()
{
	int lowGrade = grades[ 0 ]; //assume first grade is minimum

	//loop through grades array
	for ( int i = 1; i < students ; i ++)
		//if current grade is lower than lowGrade, assign to lowGrade
		if (grades[ i ] < lowGrade)
			lowGrade = grades [ i ];   //new lowGrade
	return lowGrade;
} //end of getMinimum
//********** find maximum grade ********
int gradeBank::getMaximum ()
{
	int highGrade = grades[ 0 ]; //assume first grade is maximum
	
	//loop through grade array
	for ( int i = 1; i < students ; i ++)
		//if current grade is higher than highGrade, assign to highGrade
		if (grades[ i ] > highGrade)
			highGrade = grades [ i ];   //new lowGrade
	return highGrade;
} //end of getMaximum
//********** find maximum grade ********
double gradeBank::getAverage()
{
	int total = 0;
	//sum grades in array
	for ( int i = 0; i < students ; i++)
		total += grades[ i ];
	return (double) total / students;
} //end of getAverage
//************outputGrades**********
void gradeBank::outputGrades()
{
	cout << "\nThe grades are :\n\n";
		//output each student's grade
	for ( int i = 0; i < students; i ++)
		cout << "student " << setw ( 2 ) << i + 1 << " : " 
		<< setw( 3 ) << grades [ i ] << endl;
} // end of function outputGrades