#include "stdafx.h"
#include "Students.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>

using namespace std;

#define SIZE 3

int   menu();
int   findSlot();
void  search();
void  del();
void  findMax();
void  report();
void  title();
Students st[SIZE];

int main()
{
   int i, c;
   for(;;) {
	   std::system("cls");  //clear screen
      c = menu();
      switch (c) {
	     case 1 :
	        i = findSlot();
	        if(i == -1) {
		        cout << "\n List is full. press a key...";
		        cin.get();
	        } //end of if
	        else
		        st[i].enter();
	        break;
	     case 2 :
	        findMax();
	        break;
	     case 3 :
	        del();
	        break;
	     case 4 :
	        search();
	        break;
	     case 5 :
	        report();
	        break;
	     case 6 :
	        exit(0) ;
      } // end of switch
   } //end of for(;;)
}
//*************************
int menu()
{
  int c;
  cout << endl;
  cout << "1) Enter a student." << endl;
  cout << "2) Find best student." << endl;
  cout << "3) Delete a student." << endl;
  cout << "4) Search a student." << endl;
  cout << "5) Report list." << endl;
  cout << "6) Exit." << endl;
  do {
     cout << "Enter your select(1-6) : ";
     cin >> c;
  } while (c < 1 && c > 6);
  cin.get(); //discard end of line character
  return c;
}

int findSlot()
{
  int slot;
  for(slot = 0; slot < SIZE && st[slot].getState() != ""; slot ++);
  if(slot == SIZE)
     return -1;
  return slot;
}
//**********************************
void findMax()
{
   int i, p = 0;
   float mAve = st[0].getAve();
   for(i = 1; i < SIZE; i++)
     if(st[i].getAve() > mAve)
	 {
	    mAve =  st[i].getAve();
	    p = i;
     }
     title();
     st[p].print();
     cout << "Press any key to continue . " ;
     cin.get();
}
//************************
void del()
{
   int i, no;
   cout << "\nEnter stno to delete :";
   cin >> no;
   cin.get(); //discard the end of line character
   for(i = 0; i < SIZE && st[i].getStno() != no  ; i ++);
   if(i == SIZE || (st[i].getState()) == "")  
   {
	 cout << "Student " << no << " not exist."
	      << "Press a key to continue...";
   }
   else
   {
       st[i].setNull();
       cout << "student " << no << " dleted.";
   }
   cin.get();
}
//****************
void search()
{
   int i, no;
   cout << "\nEnter stno to search :";
   cin >> no;
   cin.get();  //discard the end of line character
   for(i = 0; i < SIZE && st[i].getStno() != no ; i ++);
   if(i == SIZE || st[i].getState() == "")
   {
	 cout << "Student " << no << " not exist." ;
   }
   else
   {
      title();
      st[i].print();
   }
   cout << "\nPress a key to continue . " ;
   cin.get();
}
//********************
void report()
{
  int i;
  title();
  for(i = 0; i < SIZE; i ++) 
  {
    if(st[i].getState() != "")
       st[i].print();
  }
  cout << "\nPress any key to continue " ;
  cin.get();
}
//***********************
void title()
{
  cout << setw(10) << "name" << setw(10) << " stno "
       << setw(10) <<  "average" << endl;
  cout << "---------------------------------------" << endl;

}