#include "StdAfx.h"
#include "arrayMemStates.h"
#include <iostream>
using namespace std;

arrayMemStates::arrayMemStates(void)
{
      bytesAlloc = 0;
      bytesDel = 0;
      callsToNewArray = 0;
      callsToDelArray = 0;
}
//***********************
arrayMemStates::~arrayMemStates(void)
{
	   cout << "Memory allocation statistics : "  << endl
		<< "bytes allocated  : " << bytesAlloc << endl
		<< "bytes deleted    : " << bytesDel   << endl
		<< "calls to new[]   : " << callsToNewArray   << endl
		<< "calls to delete[]: " << callsToDelArray   << endl ;
        cin.get();
}
//************************
void arrayMemStates::newArrayCalled(size_t size)
{
      callsToNewArray ++;
      bytesAlloc += size;
}
//*************************
void arrayMemStates::delArrayCalled(size_t size)
{
      callsToDelArray ++;
      bytesDel += size;
}

