#include "StdAfx.h"
#include "studentData.h"
#include <string>
#include <iostream>
using namespace std;

// default studentData constructor
studentData::studentData( int studentNumberValue, 
   string lastNameValue, string firstNameValue, double averageValue )
{
   setStudentNumber( studentNumberValue );
   setLastName( lastNameValue );
   setFirstName( firstNameValue );
   setAverage( averageValue );
} // end studentData constructor


int studentData::getStudentNumber() const
{
   return studentNumber;
} // end function getStudentNumber

// set student-number value
void studentData::setStudentNumber( int accountNumberValue )
{
   studentNumber = accountNumberValue; // should validate
} // end function setStudenttNumber

// get last-name value
string studentData::getLastName() const
{
   return lastName;
} // end function getLastName

// set last-name value
void studentData::setLastName( string lastNameString )
{
   // copy at most 15 characters from string to lastName
   int length = lastNameString.size();
   length = ( length < 15 ? length : 14 );
   lastNameString.copy( lastName, length );
   lastName[ length ] = '\0'; // append null character to lastName
} // end function setLastName

// get first-name value
string studentData::getFirstName() const
{
   return firstName;
} // end function getFirstName

// set first-name value
void studentData::setFirstName( string firstNameString )
{
   // copy at most 10 characters from string to firstName
   int length = firstNameString.size();
   length = ( length < 10 ? length : 9 );
   firstNameString.copy( firstName, length );
   firstName[ length ] = '\0'; // append null character to firstName
} // end function setFirstName

// get average value
double studentData::getAverage() const
{
   return average;
} // end function getAverage

// set average value
void studentData::setAverage( double averageValue )
{
   average = averageValue;
} // end function setAverage



