#include "stdafx.h"
#include "point.h"
#include "circle.h"
using namespace std;

int main()
{
  point *pointPtr = 0, p(30, 50);
  circle *circlePtr = 0, c(2.7, 120, 89);

  cout << "point p: " << p << endl 
	   << "\circle c: " << c << endl;
  //treat a circle as a point(see only the base class part)

  pointPtr = &c; //assign address of circle to pointPtr
  cout << "\ncircle c (via *pointPtr): "
	  << (*pointPtr) << '\n';
  
  //treat a circle as a circle(with some casting)
  pointPtr = &c;
  //cast base-class pointer to derived-class pointer
  circlePtr = static_cast<circle *>(pointPtr);
  cout << "\ncircle c(via *circleptr) :\n" << *circlePtr
       << "\nArea of c(via circlePtr): "
       << circlePtr -> area() << endl;
  
  //DANGEROUS: treat a point as a circle
  pointPtr = &p;
  //cast base-class pointer to derived-class pointer
  circlePtr = static_cast<circle *>(pointPtr);
  cin.get();
}
