#include "StdAfx.h"
#include "circle.h"
#include <iomanip>

circle::circle(double r, int a, int b) : point(a, b) //call base class constructor
{
  setRadius(r);
}

//****************
void circle::setRadius(double r)
{
   radius = (r >= 0 ? r : 0);
}
//****get radius of circle
double circle::getRadius() const
{
   return radius;
}
//calculate area of circle
double circle::area() const
{
   return 3.14159 * radius * radius;
}
//**output a circle in the form:
//center = [x, y]; radius = #.##
ostream &operator<<( ostream &output, const circle &c)
{
   output << "Center = " << static_cast < point >( c )
          << "; Radius = " << c.radius;
   return output;
}

