#include "StdAfx.h"
#include "boss.h"
#include <iostream>
using namespace std;

boss::boss(const string &first, const string &last, double s)
	   : employee(first, last) //call base-class constructor
{
   setWeeklySalary(s);
}
//***************
//set the boss's salary
void boss::setWeeklySalary(double s)
{
   weeklySalary = s > 0 ? s : 0 ;
}
//**********************
double boss::earnings() const
{
   return weeklySalary;
}
//*****************
void boss::print() const
{
   cout <<"\nboss: ";
   employee::print();
}
