#include "StdAfx.h"
#include "commissionWorker.h"
#include <iostream>
using namespace std;

commissionWorker:: commissionWorker(const string &first,
	const string &last , double s, double c, int q)
	: employee(first, last) //call base-class constructor
{
     setSalary(s);
     setCommission(c);
     setQuantity(q);
}
//***************
void commissionWorker::setSalary(double s)
{
  salary = s > 0 ? s : 0;
}
//***************
void commissionWorker::setCommission(double c)
{
  commission = c > 0 ? c : 0;
}
//*****************
void commissionWorker::setQuantity(int q)
{
  quantity = q > 0 ? q : 0;
}
//*****************
double commissionWorker::earnings() const
{
  return salary + commission * quantity;
}
//*******************
void commissionWorker::print() const
{
  cout << "\ncommission worker : ";
  employee::print();
}
