#include <stdexcept> // stdexcept header file contains runtime_error
#include <iostream>
using namespace std;

// DivideByZeroException objects should be thrown by functions
// upon detecting division-by-zero exceptions
class divideByZeroException : public runtime_error 
{
   public:
      // constructor specifies default error message
      divideByZeroException()
         : runtime_error( "attempted to divide by zero" ) {}
}; // end class DivideByZeroException
