#include "StdAfx.h"
#include "linkList.h"
#include "node.h"
#include <iostream>
#include <iomanip>
using namespace std;

linkList::linkList()
{
   first = last = NULL;
}
//************
linkList::~linkList()
{
  node *curPtr  = new node();
  curPtr = first;
  node *temp;
  while(curPtr)
  {
      temp = curPtr;
      curPtr = curPtr -> next;
      delete temp;
  }
}
//*******************
void linkList:: delNode(int &no)
{
  node *curPtr = first, *nextPtr = first ;
  while(nextPtr)
  {
     if(no == nextPtr -> stno )
	  if (nextPtr == first)
	  {
	      first = first -> next;
	      delete nextPtr;
	      break;
	  }
	  else
	  {
	       if (nextPtr == last)
		   last = curPtr;
	       curPtr -> next = nextPtr -> next;
	       delete nextPtr;
	       break;
	  }
     else
	 {
	  curPtr  = nextPtr;
	  nextPtr = nextPtr -> next;
     }
  }
}
//******************
void linkList::addNode()
{
   node *newPtr = new node();
   if(!newPtr)
   {
     cout << "Allocation error";
     cin.get();
   }
   newPtr -> next = NULL;
   cout << "Enter name, stno, ave : \n" ;
   cin >> newPtr -> name >> newPtr -> stno >> newPtr -> ave;  
   if (first == NULL)
      first = last = newPtr;
   else 
   {
	last -> next = newPtr;
	last = newPtr;
   }
}
//****************
void linkList::display()
{
  cout << "name              "
       << "stno     " << "  average\n";
  cout << "------------------------------------\n";
  node *curPtr = first;
  while(curPtr)
  {
     cout << left << setw(13) << curPtr -> name << "     ";
     cout << left << setw(9) << curPtr -> stno << "  ";
     cout << left << setw(7) <<  curPtr -> ave << "  " << endl;
     curPtr = curPtr -> next;
  }
  cout << "\nPress a ke to continue...";
}

