#include "stdafx.h"
#include <iostream>
#include "list.h"

template <class T>
void testList(list <T> &listobject, char *type)
{
  int choice;
  T value;
  do {
     system("cls");
     instructions();
     cout << "Enter your choice ? ";
     cin >> choice;
	 cin.ignore ();
     switch(choice) {
	case 1:
	   cout << "Enter " << type << ": ";
	   cin >> value;
       cin.ignore ();
	   listobject.insertAtFront(value);
	   break;
	case 2:
	   cout << "Enter " << type << ": ";
	   cin >> value;
	   cin.ignore ();
       listobject.insertAtBack(value);
	   break;
	case 3:
	   if ( listobject.removeFromFront(value))
	   {
	      cout << value << " Removed from list\n";
	      cin.get();
	   }
	   break;
	case 4:
	   if ( listobject.removeFromBack(value))
	   {
	      cout << value << " Removed from list\n";
	      cin.get();
	   }
	   break;
	case 5:
	   listobject.print();
	   break;
     }
   } while(choice != 6);
   cout << "End list test.\n";
}
//*********************
void instructions()
{
  cout << "1. Insert at begining of list\n"
       << "2. Insert at the end of list\n"
       << "3. To delete from begining of list\n"
       << "4. To delete from end of list\n"
       << "5. Display of list \n"
       << "6. End of list processing\n";
}
//*************
int main()
{
  char ans;
  cout << "int list or float list(i or f):";
  cin  >> ans;
  if ( ans == 'i')
  {
     list<int> integerList;
     testList(integerList, "Integer");
   }
  else if ( ans == 'f') 
  {
     list<float> floatList;
     testList(floatList, "Float");
  }
  cin.get();
}
