#include "StdAfx.h"
#include "doubleLinkList.h"
#include <iostream>
#include <iomanip>
using namespace std;

doubleLinkList::doubleLinkList()
{
   first = last = NULL;
}
//************
doubleLinkList::~doubleLinkList()
{
  Node *curPtr = first;
  Node *temp;
  while(curPtr) 
  {
      temp = curPtr;
      delete temp;
      curPtr = curPtr -> next;
  }
}
//*******************
void doubleLinkList:: delNode(int &no)
{
  Node *curPtr = first ;
  while(curPtr) 
  {
     if(no == curPtr -> stno ) //if node is first node
	 {
  	    if (curPtr == first) 
	    {
	       first = first -> next;
	     //  first -> prior = NULL;
	       delete curPtr;
	       break;
	   }//end if
	   else   //if node is not the first node
	   {
	       if (curPtr == last)
		   last = curPtr -> prior;
	       curPtr -> prior -> next = curPtr -> next;
	       curPtr -> next -> prior = curPtr -> prior;
	       delete curPtr;
	       break;
	  }//end else
	 }//end if
     else
	  curPtr = curPtr -> next;
  }
}
//******************
void doubleLinkList::addNode()
{
   Node *newPtr = new Node();
   if(!newPtr)
   {
     cout << "allocation error";
     cin.get();
   }
   newPtr -> next = newPtr ->prior = NULL;
   cout << "name, stno, average : \n" ;
   cin >> newPtr -> name >> newPtr -> stno >> newPtr -> ave;
   if (first == NULL)
      first = last = newPtr;
   else
   {
	  last -> next = newPtr;
	  newPtr ->prior = last;
	  last = newPtr;
   }
}
//****************
void doubleLinkList::display()
{
  cout << "Name              "
       << "Stno     " << "  Average\n";
  cout << "-------------------------------------------\n";
  Node *curPtr = first;
  while(curPtr)
  {
     cout << left << setw(13) << curPtr -> name << "     ";
     cout << left << setw(9) << curPtr -> stno << "  ";
     cout << left << setw(7) <<  curPtr -> ave << "  " << endl;
     curPtr = curPtr -> next;
  }
  cin.get();
}
