#include "stdafx.h"
#include <iostream>
#include <string>
using namespace std;

int main()
{
   string string1( "Testing the string processing functions." );
   string string2( "Hello" ); 
   string string3( "stinger" );
   string string4 = string1;
   
   cout << "string1: " << string1 << "\nstring2: " << string2
      << "\nstring3: " << string3 << "\nstring4: " << string4 << "\n\n";

   // comparing string1 and string4
   if ( string1 == string4 )
      cout << "string1 == string4\n";
   else // string1 != string4 
   { 
      if ( string1 > string4 )
         cout << "string1 > string4\n";
      else // string1 < string4
         cout << "string1 < string4\n";
   } // end else

   // comparing string1 and string2
   int result = string1.compare( string2 );

   if ( result == 0 )
      cout << "string1.compare( string2 ) == 0\n";
   else // result != 0
   {
      if ( result > 0 )
         cout << "string1.compare( string2 ) > 0\n";
      else // result < 0
         cout << "string1.compare( string2 ) < 0\n";
   } // end else

   // comparing string1 (elements 2-5) and string3 (elements 0-5)
   result = string1.compare( 2, 5, string3, 0, 5 );

   if ( result == 0 )
      cout << "string1.compare( 2, 5, string3, 0, 5 ) == 0\n";
   else // result != 0
   {
      if ( result > 0 )
         cout << "string1.compare( 2, 5, string3, 0, 5 ) > 0\n";
      else // result < 0
         cout << "string1.compare( 2, 5, string3, 0, 5 ) < 0\n";
   } // end else

   // comparing string2 and string4
   result = string4.compare( 0, string2.length(), string2 );

   if ( result == 0 )
      cout << "string4.compare( 0, string2.length(), " 
         << "string2 ) == 0" << endl;
   else // result != 0
   {
      if ( result > 0 )
         cout << "string4.compare( 0, string2.length(), "
            << "string2 ) > 0" << endl;
      else // result < 0
         cout << "string4.compare( 0, string2.length(), "
            << "string2 ) < 0" << endl;
   } // end else
   
   // comparing string2 and string4
   result = string2.compare( 0, 3, string4 );

   if ( result == 0 )
      cout << "string2.compare( 0, 3, string4 ) == 0" << endl;
   else // result != 0
   {
      if ( result > 0 )
         cout << "string2.compare( 0, 3, string4 ) > 0" << endl;
      else // result < 0
         cout << "string2.compare( 0, 3, string4 ) < 0" << endl;
   } // end else
   //retrieve substring of string1
   cout << string1.substr  (12, 18) << endl;
   //swapping strings
   cout << "\nbefore swapping string2, string3 :" << endl;
   cout << "string2 = " << string2 << " , string3 = " << string3 << endl;
   string2.swap (string3);
   cout << "\nafter swapping string2, string3 : " << endl;
   cout << "string2 = " << string2 << " , string3 = " << string3 << endl;
   //find substring
   int location;
   location = string1.find("processing");
   cout << "\nfind substring \"processing\" in string1 at location " << location << endl;
   location = string1.find_first_of("st");
   cout << "find_first_of (st) in string1 is " << location << endl;
   location = string1.find_first_not_of("Tester");
   cout << "string1.find_first_not_of(Tester) is " << location ;
   cin.get();
} // end main

