#include "stdafx.h"
#include <iostream>
using namespace std;

class Date 
{
    friend ostream &operator<<(ostream &, const Date &);
  public:
    Date(int m = 1, int d = 1, int y = 1370); //constructor
    void setDate(int, int, int); //set the Date
    Date &operator++();          //preincrement operator
    Date operator++(int);        //postincrement operator
    const Date &operator+=(int); //add days, modify object
    bool endOfMonth(int);         //is this end of month?
  private:
    int month;
    int day;
    int year;
    static const int days[];     //array of days per month
    void helpIncrement();        //utility function
};

