#include "stdafx.h"
#include "Customer.h"
#include <iostream>
#include <fstream>
#include <string>
#include <iomanip>
using namespace std;

void enterData();
int menu();
void transaction();
void maxBalance();
void closeAccount();
void reportData();

int main()
{
   for(;;)
   {
  	   std::system("cls");
	   int c = menu();
	   switch(c) {
	       case 1 :
			   enterData();
			   break;
	       case 2 :
			   transaction(); 
			   break;
	       case 3 :
			   maxBalance(); 
			   break;
	       case 4 :
			   closeAccount();
			   break;
	       case 5 :
			   reportData(); 
			   break;
	       case 6 :
			   exit(0);
	   } //end of switch
   } //end of for
}
//***********************
int menu()
{
    int p;
    cout << "1. Enter data" << endl;
    cout << "2. Transaction" << endl;
    cout << "3. Maximu balance" << endl;
    cout << "4. Close  customer account" << endl;
    cout << "5. Report the file" << endl;
    cout << "6. Terminate program" << endl;
    cout << "Enter your select(1-6) : ";
    cin >> p;
    cin.get();   //clear the keyboard buffer
    return p ;
}
//********************
void enterData()
{
	Customer client;
	fstream fp("bank.dat", ios::out | ios::in | ios::binary);
	if(!fp)
	{
		//Create file
        ofstream fp1("bank.dat" , ios::out | ios::binary );
		//write a blank record 
		fp1.write((char *) &client, sizeof(Customer));
		fp1.close();
	}

   	fstream fp2("bank.dat", ios::out | ios::in | ios::binary);
	string name;
    int balance;
	int accountNumber;
	int accountType;
	cout << "Enter name, balance, accountNumber, accountType :\n";
	cin >> name >> balance >> accountNumber >> accountType;
	cin.ignore (); //discard end of line char

	client.setState(1);
	client.setName(name);
	client.setBalance (balance);
	client.setAccountNumber(accountNumber);
	client.setAccountType (accountType);
	fp2.seekp(sizeof(Customer) * (client.getAccountNumber() - 1), ios::beg );
	fp2.write((char *) &client, sizeof(Customer));
	fp2.close();
}
//*********************
void reportData()
{
	std::system("cls");
	cout << "Name        " << "Balance       Account#      AccountType"
		 << endl;
	cout << "----------------------------------------------------"
		 << endl; 
   Customer client;
   fstream fp("bank.dat", ios::out | ios::in | ios::binary);
   fp.read( ( char * )( &client ), sizeof( Customer ) );
   // read all records from file
   while ( fp && !fp.eof() ) 
   {
      // display record
      if ( client.getState() == 1)
	  {
           cout << left << setw( 14 ) << client.getName()
             << setw( 18 ) << client.getBalance()
             << setw( 12 ) << client.getAccountNumber()
             << setw( 12 ) << client.getAccountType() << endl  ; 
	  }
      // read next from file
      fp.read( (char * )( &client ), sizeof( Customer ) );
   } // end while
   cout << "\nPress a key to continue...";
   fp.close();
   cin.get();
}
//**********************
void maxBalance()
{
    ifstream fp("bank.dat", ios::in | ios::binary);
	Customer client, maxClient;
	maxClient.setBalance(0);

	std::system("cls");
	cout << "Name        " << "Balance       Account#      AccountType"
		 << endl;
	cout << "----------------------------------------------------"
		 << endl; 
   fp.read( ( char * )( &client ), sizeof( Customer ) );
   // read all records from file
   while ( fp && !fp.eof() ) 
   {
	   if ( client.getState () == 1)
	   {
		   if (client.getBalance () > maxClient.getBalance ())
			   maxClient = client;
	   }
	   
	   fp.read( (char * )( &client ), sizeof( Customer ) );
   } // end while

   cout << left << setw( 14 ) << maxClient.getName()
             << setw( 18 ) << maxClient.getBalance()
             << setw( 12 ) << maxClient.getAccountNumber()
             << setw( 12 ) << maxClient.getAccountType() << endl; 
   fp.close();
   cout << "\nPress a key to continue ...";
   cin.get();
}
//************************************
void closeAccount()
{
	int acNumber; //account number to close
	Customer client;
	cout << "Enter account number to close : " ;
	cin >> acNumber;
	cin.ignore();  //discard end of line character
	fstream fp("bank.dat", ios::out | ios::in | ios::binary);
	fp.seekg(sizeof(Customer) * ( acNumber -1 ));

    fp.read( (char *) ( &client ), sizeof( Customer ) );
	client.setState (0);
	fp.seekp(sizeof(Customer) * ( acNumber - 1 ) );
    fp.write ((char *) &client, sizeof(Customer));
	fp.close();
	cin.get();
}
//************************
void transaction()
{
	char trans;  //d for deposite, w for withdraw
	int acNumber, amount;
	Customer client;
	fstream fp("bank.dat", ios::out | ios::in | ios::binary);

	cout << "Enter acNumber , amount : ";
	cin >> acNumber >> amount;
	fp.seekg(sizeof(Customer) * (acNumber - 1), ios::beg );
	fp.read((char *) (&client), sizeof(Customer));

	cout << "Do you want to deposite(d) or withdraw(w) ? ";
	cin >> trans;
	if(trans == 'd')
		client.setBalance (client.getBalance () + amount);
	else
		client.setBalance (client.getBalance () - amount);
	fp.seekp(sizeof(Customer) * (acNumber - 1), ios::beg );
	fp.write((char *) (&client), sizeof(Customer));
    fp.close();
}

