#include "StdAfx.h"
#include "Customer.h"

 Customer::Customer(int stateValue, string nameValue, int balanceValue,
	       int accountNumberValue, int accountTypeValue)
 {
	 setState(stateValue);
	 setName(nameValue);
	 setBalance(balanceValue);
     setAccountNumber(accountNumberValue);
	 setAccountType(accountTypeValue);
 }
 //*******************
 void Customer::setState(int stateValue)
 {
	 state = stateValue;
 }
 //********************
 int Customer::getState() 
 {
	 return state;
 }
 //********************
 void Customer::setName(string nameValue)
 {
   int length = nameValue.size();
   length = ( length < 15 ? length : 14 );
   nameValue.copy( name, length );
   name[ length ] = '\0'; // append null character to firstName
 }
 //********************
 string Customer::getName()
 {
	 return name;
 }
 //************************
 void Customer::setBalance(int balanceValue)
 {
	 balance = balanceValue;
 }
 //********************
 int Customer::getBalance() 
 {
	 return balance;
 }
 //********************
 void Customer::setAccountNumber(int accountNumberValue)
 {
	 accountNumber = accountNumberValue;
 }
 //********************
 int Customer::getAccountNumber() 
 {
	 return accountNumber;
 }
 //*******************
 void Customer::setAccountType(int accountTypeValue)
 {
	 accountType = accountTypeValue;
 }
 //********************
 int Customer::getAccountType() 
 {
	 return accountType;
 }



